<?php

# execute using following command
# php mr_newtest.php -d database_name -h database_host -u db_user

$shortopts = "d:h:u:p:";
$options = getopt($shortopts);


if (array_key_exists('d', $options)) {
	    $database = $options['d'];
} else {
	    die("no database specified with -d switch\n");
}

if (array_key_exists('h', $options)) {
	    $host = $options['h'];
} else {
	    die("no host specified with -h switch\n");
}


if (array_key_exists('u', $options)) {
	    $user = $options['u'];
} else {
	    die("no user specified with -u switch\n");
}

if (array_key_exists('p', $options)) {
	    $password = $options['p'];
} else {
            echo "Enter password:\n";
            system('stty -echo');
            $password = trim(fgets(STDIN));
            system('stty echo');
}

$mysqli = mysqli_connect($host, $user, $password, $database);
if (mysqli_connect_errno($mysqli)) {
	  echo "Failed to connect to $database: " . mysqli_connect_error();
}
$date = date('m/d/Y h:i:s a', time());
echo "$date: dropping new_tests table if it exists\n";
$res = mysqli_query($mysqli, 'drop table if exists new_tests') or die(mysqli_error($mysqli));

$date = date('m/d/Y h:i:s a', time());
echo "$date: dropping deadwood_tests table if it exists\n";
$res = mysqli_query($mysqli, 'drop table if exists deadwood_tests') or die(mysqli_error($mysqli));

$date = date('m/d/Y h:i:s a', time());
echo "$date: dropping old_tests table if it exists\n";
$res = mysqli_query($mysqli, 'drop table if exists old_tests') or die(mysqli_error($mysqli));

$date = date('m/d/Y h:i:s a', time());
echo "$date: creating new_tests table\n";
$res = mysqli_query($mysqli, "create table new_tests like tests") or die(mysqli_error($mysqli));

$date = date('m/d/Y h:i:s a', time());
echo "$date: creating deadwood_tests table\n";
$res = mysqli_query($mysqli, "create table deadwood_tests like tests") or die(mysqli_error($mysqli));

$date = date('m/d/Y h:i:s a', time());
echo "$date: Locking all tables\n";
$res = mysqli_query($mysqli, 'lock table tests read, new_tests write, deadwood_tests write') or die(mysqli_error($mysqli));

$date = date('m/d/Y h:i:s a', time());
echo "$date: inserting is_selected = 1 tests into new_tests table\n";
$query =  "insert into new_tests select * from tests where is_selected = 1"; 

$date = date('m/d/Y h:i:s a', time());
echo "$date: $query\n";
$res = mysqli_query($mysqli, $query) or die(mysqli_error($mysqli));

$date = date('m/d/Y h:i:s a', time());
echo "$date: inserting is_selected = 0 tests into deadwood_tests table\n";
$query =  "insert into deadwood_tests select * from tests where is_selected = 0";

$date = date('m/d/Y h:i:s a', time());
echo "$date: $query\n";
$res = mysqli_query($mysqli, $query) or die(mysqli_error($mysqli));

$date = date('m/d/Y h:i:s a', time());
echo "$date: counting rows in new_tests table\n";
$res = mysqli_query($mysqli, 'select count(id) as tests FROM new_tests') or die(mysqli_error($mysqli));
if (mysqli_num_rows($res) > 0) {
	   $row = mysqli_fetch_assoc($res);
	      $tests = $row['tests'];
	      $date = date('m/d/Y h:i:s a', time());
	         echo "$date: Number of rows in new_tests table: $tests\n";
}

$date = date('m/d/Y h:i:s a', time());
echo "$date: counting rows in deadwood_tests table\n";
$res = mysqli_query($mysqli, 'select count(id) as tests FROM deadwood_tests') or die(mysqli_error($mysqli));
if (mysqli_num_rows($res) > 0) {
           $row = mysqli_fetch_assoc($res);
              $tests = $row['tests'];
              $date = date('m/d/Y h:i:s a', time());
                 echo "$date: Number of rows in deadwood_tests table: $tests\n";
}

$date = date('m/d/Y h:i:s a', time());
echo "$date: unlocking all tables\n";
$res = mysqli_query($mysqli, 'unlock tables;') or die(mysqli_error($mysqli));

$date = date('m/d/Y h:i:s a', time());
echo "$date: Renaming tables\n";
$res = mysqli_query($mysqli, 'rename table tests to old_tests') or die(mysqli_error($mysqli));
$res = mysqli_query($mysqli, 'rename table new_tests to tests') or die(mysqli_error($mysqli));
$date = date('m/d/Y h:i:s a', time());

$date = date('m/d/Y h:i:s a', time());
echo "$date: dropping old_tests table\n";
$res = mysqli_query($mysqli, 'drop table if exists old_tests') or die(mysqli_error($mysqli));

$date = date('m/d/Y h:i:s a', time());
echo "$date: Finished.\n";



